Subject: bug#56682: Fix the long lines font locking related slowdowns

From: Eli Zaretskii <[email-masked]>
Date: Sun, 07 Aug 2022 17:07:55 +0300

> Date: Sun, 07 Aug 2022 00:29:05 +0000
> From: Gregory Heytings <[email-masked]>
> cc: [email-masked], [email-masked], [email-masked], 
>     [email-masked]
> 
> Thanks!  Indeed these problem seem fixed now, it's much better.  I did not 
> see any regressions, if I see anything I'll tell you.  One case that still 
> isn't quite right apparently is the arabic-small.txt.json file.  If I open 
> that file with emacs -Q and type C-f, or C-n, or C-p, point moves to EOB 
> (but strangly, not in 100% cases), and there C-a, or M-<, or C-p, or C-n 
> do not seem to work anymore.

Indeed.  But what you perhaps don't realize is that in this case what
is shown on the last screen-full is not EOB, but BOB!  That's because
everything is reordered for display, so the first character appears
last.

I've fixed some more issues with such (relatively rare) situations, so
now these commands should work more reasonably (but very slowly) after
C-f in that file.